#!/usr/bin/ruby
# coding: utf-8
require 'yaml'


# 注意:
#   以下の変数は, 下の別の箇所でもハードコーディングされている ('' で
#   囲まれたヒアドキュメント内に入っている) ため, ここで変更するだけでは
#   済まない.
#     正確には, file_htmltop, file_htmlbot はここで指定するだけでよいが.
file_htmlhead = "paramexp-cgi_htmlhead.txt"
file_htmltop  = "paramexp-cgi_htmltop.txt"
file_htmlbot  = "paramexp-cgi_htmlbot.txt"
file_cgitop   = "paramexp-cgi_cgitop.txt"
file_cgibot   = "paramexp-cgi_cgibot.txt"
file_yaml     = "paramexp-cgi.yml"


def put_message( line )
  put_header
  print line, "\n"
  print "<br>"
  put_footer
end
def put_header( title_txt = "", head = "" )
#    Content-type: text/html; charset=utf-8
  print <<~EOD1
    <html lang="ja">
    <head>
      <meta charset="utf-8">
  EOD1
  print head
  print "\n"
  print <<~EOD2
      <title>
  EOD2
  print title_txt
  print <<~EOD3
      </title>
    </head>
    <body onload="show_hide_parameter( )">
  EOD3
end
def put_footer
  print <<~EOD
    <script language="JavaScript">
      <!--

        function show_hide_parameter( )
        {

          // debug
          console.log( "In show_hide_parameter" );

          var obj_paramaxis1 = document.getElementById( "id_select_param_axis1" );
          var obj_paramaxis2 = document.getElementById( "id_select_param_axis2" );

          // チェック用パラメータリスト
          var obj_param_list = obj_paramaxis1

          // debug
          // パラメータの表示
          console.log( "  param list length : " + obj_param_list.options.length );
          for (let i = 0; i < obj_param_list.options.length; i++) {
                console.log( "    " + i + " : " + obj_param_list.options[i].value );
          }

          var idx              = obj_paramaxis1.selectedIndex;
          var paramaxis1_value = obj_paramaxis1.options[idx].value; // 値
          var idx              = obj_paramaxis2.selectedIndex;
          var paramaxis2_value = obj_paramaxis2.options[idx].value; // 値

          // debug
          // パラメータの display set to "none" or ""
          console.log( "  param list length : " + obj_param_list.options.length );
          for (let i = 0; i < obj_param_list.options.length; i++) {
            // debug
            console.log( "    " + i + " : " + obj_param_list.options[i].value );

            //var id  = "id_select_" + obj_param_list.options[i].value
            var id  = "id_tr_" + obj_param_list.options[i].value
            var obj = document.getElementById( id );

            // debug
            console.log( '      display status : ' + obj.style.display );

            if ( obj_param_list.options.length > 2 )
            {
              // Only some of parameters are shown, if number of parameters is
              // greater than 2.
              if (    ( obj_param_list.options[i].value == paramaxis1_value )
                   || ( obj_param_list.options[i].value == paramaxis2_value ) )
              {
                obj.style.display = "none"
              } else {
                // obj.style.display = "block"
                obj.style.display = ""
              }
            } else {
              // All parameters are not shown.
              obj.style.display = "none"
            }

            // debug
            console.log( '      display status : ' + obj.style.display );

          }

        }

      -->
    </script>

    </body>
    </html>
  EOD
end

# This is an unnecessary line. This is written to change a style on emacs.
#</


yml_input = YAML.load_file( file_yaml )

nparams = yml_input["parameters"].size
if nparams < 2 then
  STDERR.print "Error: Number of parameters has to be 2 or larger.\n"
  exit
end

file_cgi = yml_input["file_cgi"]


if yml_input.key?(:html_titletxt) then
  html_titletxt = ""
else
  html_titletxt = yml_input["html_titletxt"]
end

if File.exist?( file_htmlhead ) then
  f = File.open( file_htmlhead, "r" )
  html_head = f.read  # 全て読み込む
  f.close
else
  html_head = ""
end

put_header( html_titletxt, html_head )

if File.exist?( file_htmltop ) then
  f = File.open( file_htmltop, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

print '  <div style="margin-left:2em">'

print "    <form method=get action=", file_cgi, ">"
print "\n"

nvars = yml_input["file_figs"].size
vars  = yml_input["file_figs"].keys
#
print "       物理量 :", "\n"
print '       <select name="variable">'
print "\n", "<br>", "\n"
for ivar in 0..(nvars-1)
  var       = vars[ivar]
  long_name = yml_input["file_figs"][var]
  if long_name == nil then
    long_name = var
  end
  if ivar == 0 then
    print '         <option value="', var, '" selected>'
  else
    print '         <option value="', var, '">'
  end
  print "           ", long_name
  print "         </option>"
  print "\n"
end
print '       </select>'
print "\n", "<br>", "\n"


print "\n", "<br>", "\n"


#print "\n", "<br>", "\n"

#################################################
# パラメータ軸
#################################################

nparams = yml_input["parameters"].size
params  = yml_input["parameters"].keys
#
print "       パラメータ軸 :"
print '       <p style="margin-left:2em; margin-top:0em">'
print "       <table>", "\n"
#
print "       <tr>"
print "         <td>横軸</td><td>:</td>"
print "         <td>"
print '           <select name="param_axis1" id="id_select_param_axis1" onchange="show_hide_parameter( )">'
print "\n", "<br>", "\n"
for iparam in 0..(nparams-1)
  param = params[iparam]

  nhash     = yml_input["parameters"][param].size
  long_name = yml_input["parameters"][param]["long_name"]
  if long_name == nil then
    long_name = param
  end
  values    = yml_input["parameters"][param]["values"]
  unit      = yml_input["parameters"][param]["unit"]

  if iparam == 0 then
    print '<option value= "', param, '" selected>', long_name, '</option>'
  else
    print '<option value= "', param, '"         >', long_name, '</option>'
  end
end
print '           </select>'
print "         </td>"
print "       </tr>"
print "\n"
#
print "       <tr>"
print "         <td>縦軸</td><td>:</td>"
print "         <td>"
print '           <select name="param_axis2" id="id_select_param_axis2" onchange="show_hide_parameter( )">'
for iparam in 0..(nparams-1)
  param = params[iparam]

  nhash     = yml_input["parameters"][param].size
  long_name = yml_input["parameters"][param]["long_name"]
  if long_name == nil then
    long_name = param
  end
  values    = yml_input["parameters"][param]["values"]
  unit      = yml_input["parameters"][param]["unit"]

  if iparam == 1 then
    print '<option value= "', param, '" selected>', long_name, '</option>'
  else
    print '<option value= "', param, '"         >', long_name, '</option>'
  end
end
print '           </select>'
print "         </td>"
print "       </tr>"
print "       </table>", "\n"
print '       </p>', "\n"

#print "\n", "<br>", "\n"
#print "\n", "<br>", "\n"


#################################################
# パラメータ軸以外のパラメータ
#################################################

nparams = yml_input["parameters"].size
params  = yml_input["parameters"].keys
#
if nparams > 2 then
  print "       パラメータ軸以外のパラメータ :", "\n"
end
print '       <p style="margin-left:2em; margin-top:0em">', "\n"
print "       <table>", "\n"
for iparam in 0..(nparams-1)
  param = params[iparam]

  nhash     = yml_input["parameters"][param].size
  default   = yml_input["parameters"][param]["default"]
  long_name = yml_input["parameters"][param]["long_name"]
  if long_name == nil then
    long_name = param
  end
  values    = yml_input["parameters"][param]["values"]
  unit      = yml_input["parameters"][param]["unit"]


  print '       <tr id="id_tr_' + param + '">', "\n"
  print '         <td>', "\n"
  print "           ", long_name, "\n"
  print '         </td>', "\n"
  print '         <td>', "\n"
  print "           ", " : ", "\n"
  print '         </td>', "\n"
  print '         <td>', "\n"
  print '           <select name="', param, '">'
  for ival in 0..(values.size-1)
    value = values[ival].to_s
    if value == default.to_s then
      print '          <option value= "', value, '" selected>', value, '</option>'
    else
      print '          <option value= "', value, '"         >', value, '</option>'
    end
    print "\n"
  end
  print '           </select>'
  print "     ", " ", unit, "\n"
  print '         </td>', "\n"
  print '       </tr>', "\n"
  print "\n"
end
print "       </table>", "\n"
print '       </p>'


#################################################
# 各図の幅
#################################################

if yml_input.key?(:fig_width) then
  fig_width = yml_input["fig_width"]
else
  fig_width = 250
end
#
print "       各図の幅 :"
#print "\n", "<br>", "\n"
#print "       &nbsp;"
#print "       &nbsp;"
print '       <input type="text" size=6 maxlength=6 name="fig_width" value=', fig_width, '>'
print " pixels", "\n"

print "\n", "<br>", "\n"
print "\n", "<br>", "\n"

print '      <input type=submit value="submit">'
print "\n", "<br>", "\n"

print "    </form>"
print '  </div>'


if File.exist?( file_htmlbot ) then
  f = File.open( file_htmlbot, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

put_footer


#########################################################
# cgi file
#########################################################

cgi_file_content = <<~'EOF'
#!/usr/bin/ruby
# coding: utf-8
require "cgi"
require 'yaml'

file_yaml   = "paramexp-cgi.yml"
file_cgitop = "paramexp-cgi_cgitop.txt"
file_cgibot = "paramexp-cgi_cgibot.txt"

def put_message( line )
  put_header
  print line, "\n"
  print "<br>"
  put_footer
end
def put_header
  print <<~EOD
  Content-type: text/html; charset=utf-8

  <html lang="ja">
  <head>
    <meta charset="utf-8">
    <!--
    <meta http-equiv="cache-control" content="private">
    -->
    <title>Parameter experiments</title>
  </head>
  <body>
  EOD
end
def put_footer
  print <<~EOD
    </body>
    </html>
  EOD
end

yml_input = YAML.load_file( file_yaml )

flag_debug     = yml_input["flag_debug"]
flag_show_info = yml_input["flag_show_info"]
flag_dirlink   = yml_input["flag_dirlink"]


pardir  = yml_input["pardir"]


params_name          = yml_input["parameters"].keys

#params_name          = ["RotPeriod", "Obl", "Radius"]
#param_rotperiod_val  = [1, 3, 10, 30, 90]
#param_rotperiod_unit = "Earth days"
#param_obl_val        = [0.0, 23.4, 60.0, 90.0]
#param_obl_unit       = "degrees"
#param_radius_val     = [6371, 4247, 3186]
#param_radius_unit    = "km"


in_hash = CGI.new


fixed_params_val = Array.new( params_name.size )
for i in 0..(params_name.size-1)
  fixed_params_val[i] = in_hash[ params_name[i] ]
end



file_fig         = in_hash[ "variable" ]
param_axis1_name = in_hash[ "param_axis1" ]
param_axis2_name = in_hash[ "param_axis2" ]
fig_width        = in_hash[ "fig_width" ]

if param_axis1_name == param_axis2_name then
  put_header
  print "Error: axis1 has to be different from axis2."
  put_footer
  print "<br>"
  exit
end

param_axis1_long_name = yml_input["parameters"][param_axis1_name]["long_name"]
param_axis1_unit      = yml_input["parameters"][param_axis1_name]["unit"]
param_axis1_vals      = yml_input["parameters"][param_axis1_name]["values"]
param_axis1_format    = yml_input["parameters"][param_axis1_name]["label_format"]
#
param_axis2_long_name = yml_input["parameters"][param_axis2_name]["long_name"]
param_axis2_unit      = yml_input["parameters"][param_axis2_name]["unit"]
param_axis2_vals      = yml_input["parameters"][param_axis2_name]["values"]
param_axis2_format    = yml_input["parameters"][param_axis2_name]["label_format"]


#put_header
#for i in 0..(params_name.size-1)
#  print params_name[i], ":", fixed_params_val[i], "\n"
#  print "<br>"
#end
#print param_axis1_name, ":", param_axis1_vals, "\n"
#print "<br>"
#print param_axis2_name, ":", param_axis2_vals, "\n"
#print "<br>"
#put_footer
#exit


# file path
fixed_param_strings = Array.new( params_name.size )
for i in 0..(params_name.size-1)
  name         = params_name[i]
  label_format = yml_input["parameters"][name]["label_format"]
  label        = sprintf( label_format, fixed_params_val[i] )
  fixed_param_strings[i] = name + label
end


fig_paths = Array.new( param_axis2_vals.size ).map{ Array.new( param_axis1_vals.size ) }
param_strings = Array.new( params_name.size )
param_strings = fixed_param_strings
for j in 0..(param_axis2_vals.size-1)
  label = sprintf( param_axis2_format, param_axis2_vals[j] )
  param_axis2_string = param_axis2_name + label
  for k in 0..(params_name.size-1)
    if params_name[k] == param_axis2_name then
      param_strings[k] = param_axis2_string
    end
  end

  for i in 0..(param_axis1_vals.size-1)
    label = sprintf( param_axis1_format, param_axis1_vals[i] )
    param_axis1_string = param_axis1_name + label
    for k in 0..(params_name.size-1)
      if params_name[k] == param_axis1_name then
        param_strings[k] = param_axis1_string
      end
    end

    string = ""
    for k in 0..(params_name.size-1)
      string += "/" + param_strings[k]
    end

    dir = pardir + string
    fig_path = dir + "/" + file_fig
    fig_paths[j][i] = fig_path
  end
end


put_header

#print "This is a test page for cgi.", "\n"


#print "Figure path:", "<br>", "\n"
#for j in 0..(fig_paths[0].size-1)
#  for i in 0..(fig_paths.size-1)
#    print "  [", i, "][", j, "] ", fig_paths[j][i], "\n"
#    print "<br>", "\n"
#  end
#end


if File.exist?( file_cgitop ) then
  f = File.open( file_cgitop, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

print "<table border=1>", "\n"

# param values
#print "  <td rowspan=", param_axis2_vals.size, ">", "\n"
#print "    ", param_axis2_name, "\n"
#print "  </td>", "\n"

#   1st line
print "<tr>", "\n"
print "  <td colspan=2 rowspan=2>", "\n"
print "  </td>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
print '  <td colspan=', param_axis1_vals.size, ' align=center>', "\n"
if param_axis1_unit == "" then
  print "    ", param_axis1_long_name, "<br>", "\n"
else
  print "    ", param_axis1_long_name, "<br>", "(", param_axis1_unit, ")", "\n"
end
print "  </td>", "\n"
print "</tr>", "\n"
#   2nd line
print "<tr>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
for i in 0..(param_axis1_vals.size-1)
  print "  <td align=center>", "\n"
  print "    ", param_axis1_vals[i], "\n"
  print "  </td>", "\n"
end
print "</tr>", "\n"

#   3rd, 4th, ... lines
for j in 0..(param_axis2_vals.size-1)

  print "<tr>", "\n"

  if j == 0 then
    print "  <td rowspan=", param_axis2_vals.size, " align=center>", "\n"
    if param_axis2_unit == "" then
      print "    ", param_axis2_long_name, "<br>", "\n"
    else
      print "    ", param_axis2_long_name, "<br>", "(", param_axis2_unit, ")", "\n"
    end
    print "  </td>", "\n"
  end

  print "  <td align=center>", "\n"
  print "    ", param_axis2_vals[j], "\n"
  print "  </td>", "\n"

  for i in 0..(param_axis1_vals.size-1)

    fig_path = fig_paths[j][i]

    print '  <td align="center">', "\n"
    if File.exist?(fig_path) then
      if File.extname(fig_path) == ".mp4" then
        print '    <video controls src="', fig_path, '" width=', fig_width, '></video>', "\n"
      else
        print '    <img src="', fig_path, '" width=', fig_width, 'alt="" title="">', "\n"
      end
      if flag_dirlink then
        print "<br>"
        print "\n"
        print '    <a href="', fig_path[0..fig_path.rindex("/")-1], '">[directory]</a>', "\n"
        print "\n"
      end
    else
      print '    No figure', "\n"
    end
    # debug
    if flag_debug then
      print '    ', fig_path, "\n"
    end
    #
    print '  </td>', "\n"
  end
  print "</tr>", "\n"

end

print "</table>", "\n"


if flag_show_info then

  print "<br>", "\n"
  print "<br>", "\n"

  #print "=======================", "\n"
  #print "<br>", "\n"
  print "<hr>", "\n"

  print "Figure file : ", file_fig, "\n"
  print "<br>", "\n"

  print "<br>", "\n"

  for i in 0..(params_name.size-1)
    print "Parameter ", i, " : ", params_name[i], "=", fixed_params_val[i], "\n"
    print "<br>", "\n"
  end

  print "<br>", "\n"

  print "Column : ", param_axis1_name, "\n"
  print "<br>", "\n"
  print "Row    : ", param_axis2_name, "\n"
  print "<br>", "\n"

  print "<br>", "\n"

  print "Figure width : ", fig_width, "\n"
  print "<br>", "\n"

  #print "=======================", "\n"
  #print "<br>", "\n"
  print "<hr>", "\n"

end

if File.exist?( file_cgibot ) then
  f = File.open( file_cgibot, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

put_footer

EOF

f = File.open( file_cgi, "w" )
f.puts cgi_file_content
f.close
File.chmod( 0755, file_cgi )
